Class: Sketchup::Drawingelement

Inherits:
Entity
  • Object
show all

Overview

Drawingelement is a base class for an item in the model that can be displayed. These items include edges, construction points, construction lines, and images. Arc curves and arcs are not included because they are not drawing elements by themselves, but are a composition of edges.

Version:

  • SketchUp 6.0

Instance Method Summary # collapse

Methods inherited from Entity

#add_observer, #attribute_dictionaries, #attribute_dictionary, #delete_attribute, #deleted?, #entityID, #get_attribute, #inspect, #model, #parent, #persistent_id, #remove_observer, #set_attribute, #to_s, #typename, #valid?

Instance Method Details

#boundsObject

The bounds method is used to retrieve the BoundingBox for an drawing element.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
# Remember, anything that can be displayed, such as a face, is also
# a Drawingelement. So I can call bounds on a face because Face
# is a sub-class of Drawingelement.
boundingbox = face.bounds

Returns:

  • boundingbox - A BoundingBox object if successful

Version:

  • SketchUp 6.0

#casts_shadows=(casts) ⇒ Object

The casts_shadows= method is used to set the Drawingelement to cast shadows.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 100]
pts[1] = [width, 0, 100]
pts[2] = [width, depth, 100]
pts[3] = [0, depth, 100]
# Add the face to the entities in the model.
face = entities.add_face pts

# Make the face not cast shadows.
status = face.casts_shadows = false
UI.messagebox status.to_s

Returns status - true if successful, false if unsuccessful.

Parameters:

  • casts

    true if you want the Drawingelement object to cast shadows, false if you do not want the Drawingelement object to cast shadows.

Returns:

  • status - true if successful, false if unsuccessful.

Version:

  • SketchUp 6.0

#casts_shadows?Object

The casts_shadows? method is used to determine if the Drawingelement is casting shadows.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
status = face.casts_shadows?
UI.messagebox status.to_s

Returns:

  • status - true if the Drawingelement is casting shadows, false if unsuccessful.

  • (Boolean)

Version:

  • SketchUp 6.0

#erase!Object

The erase! method is used to erase an element from the model.

Erasing an Edge also erases all of the Face objects that use the Edge.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
status = face.erase!

Returns:

  • status - true if successful, false if unsuccessful

Version:

  • SketchUp 6.0

#hidden=(hidden) ⇒ Object

The hidden= method is used to set the hidden status for an element.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
UI.messagebox "Click OK to Hide the Box"
status = face.hidden = true

Returns status - true if the element has been hidden, false if the element has not been hidden.

Parameters:

  • hidden

    true if you want to hide the element, false if you do not want to hide the element.

Returns:

  • status - true if the element has been hidden, false if the element has not been hidden.

Version:

  • SketchUp 6.0

#hidden?Object

The hidden? method is used to determine if the element is hidden.

Hidden elements are still in the model, but they are not displayed.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
status = face.hidden?
UI.messagebox "hidden? " + status.to_s

Returns:

  • status -true if hidden, false if not hidden

  • (Boolean)

Version:

  • SketchUp 6.0

#layerObject

The layer method is used to retrieve the Layer object of the drawing element.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
layer = face.layer

Returns:

  • layer - a layer object if successful

Version:

  • SketchUp 6.0

#layer=(layer) ⇒ Object

The layer= method is used to set the layer for the drawing element.

An exception is raised if you give a string that doesn't match any layer name.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
# Add a layer
layer = Sketchup.active_model.layers.add "joe"
# Put the face on the joe layer (instead of layer 0)
newlayer = face.layer = layer

Returns layer - the new Layer object if successful

Parameters:

Returns:

  • layer - the new Layer object if successful

Version:

  • SketchUp 6.0

#materialObject

The material method is used to retrieve the material for the drawing element.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
material = face.material

Returns:

  • material - the Material object if successful

Version:

  • SketchUp 6.0

#material=(material) ⇒ Object

The material= method is used to set the material for the drawing element.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
m = model.materials.add "Joe"
begin
  # Returns nil if not successful, path if successful.
  # Should return a texture object.
  m.texture = "c:\\My Textures\\Carpet.jpg"
rescue
  UI.messagebox $!.message
end
# You will see the material applied when you reverse the box's faces
material = face.material = m

Returns material - the new Material object if successful

Parameters:

  • material

    A Material, name of a material, Color, or name of a color.

Returns:

  • material - the new Material object if successful

Version:

  • SketchUp 6.0

#receive_shadows=(receive) ⇒ Object

The receive_shadows= method is used to set the Drawingelement to receive shadows.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 100]
pts[1] = [width, 0, 100]
pts[2] = [width, depth, 100]
pts[3] = [0, depth, 100]
# Add the face to the entities in the model.
face = entities.add_face pts

# Make the face not receive shadows.
status = face.receives_shadows = false
UI.messagebox status.to_s

Returns status - true if successful, false if unsuccessful.

Parameters:

  • receive

    true if you want the Drawingelement object to receive shadows, false if not.

Returns:

  • status - true if successful, false if unsuccessful.

Version:

  • SketchUp 6.0

#receives_shadows?Object

The receive_shadows? method is used to determine if the Drawingelement is receiving shadows.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
status = face.receives_shadows?
UI.messagebox status.to_s

Returns:

  • status - true if the Drawingelement is receiving shadows, false if unsuccessful.

  • (Boolean)

Version:

  • SketchUp 6.0

#visible=(visibility) ⇒ Object

The visible= method is used to set the visible status for an element. This method performs an opposite function to the hidden= method.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
UI.messagebox "Click OK to Hide the Box"
status = face.visible = false

Returns status - true if the element has been hidden, false if the element has not been hidden.

Parameters:

  • visibility

    true if you want to hide the element, false if not

Returns:

  • status - true if the element has been hidden, false if the element has not been hidden.

Version:

  • SketchUp 6.0

#visible?Object

The visible? method is used to get the visible status for an element.

Examples:

depth = 100
width = 100
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
UI.messagebox "Click OK to Hide the Box"
face.visible = false
UI.messagebox "Is the face visible? " + face.visible?.to_s

Returns:

  • visibility - true if visible, false if not

  • (Boolean)

Version:

  • SketchUp 6.0